import angular from 'angular';
const bulk = require('bulk-require');

// Create a new angular module for this feature
const featureModule = angular.module('gsf.integration.data', []);

// Into this module, import all the angular controllers, factories, directives etc. found in this
// folder and subfolders, using naming conventions e.g. <name>.directive.js
const controllers = bulk(__dirname, ['./**/!(*index|*.spec).controller.js']);
const directives = bulk(__dirname, ['./**/!(*index|*.spec).directive.js']);
const services = bulk(__dirname, ['./**/!(*index|*.spec).service.js']);

// Load the imported items into angular
declare(controllers, featureModule.controller);
declare(directives, featureModule.directive);
declare(services, featureModule.factory);

function declare(controllerMap, declarationLoader) {
    Object.keys(controllerMap).forEach((key) => {
        let item = controllerMap[key];

        if (!item) {
            return;
        }

        if (item.fn && typeof item.fn === 'function') {
            declarationLoader(item.name, item.fn);
        } else {
            declare(item, declarationLoader);
        }
    });
}

export default featureModule;