function IntegratedData(CdmHelpers) {
	'ngInject';

	const service = {
		register: register,
        retrieveMatterEntity: retrieveMatterEntity,
        retrieveRelatedEntities: retrieveRelatedEntities,
        retrieveDatumByKey: retrieveDatumByKey,
        clear: clear
	};

	var payload = {};
    
    function register(cdm) {
        payload = cdm;
    }

    function retrieveMatterEntity() {
        return payload.MatterEntity;
    }

    function retrieveRelatedEntities(types, relationship) {
        return CdmHelpers.parseDataModel(types, relationship, null, payload);
    }

    function retrieveDatumByKey(key, /*optional*/ model) {
        if (!payload.MatterEntity) return '';

        var datumList = (model) ? model.OtherData : payload.MatterEntity.OtherData;

        if (!(datumList instanceof Array) || datumList.length < 1) return '';

        var datumVal = CdmHelpers.getDatumVal(datumList, key);

        return datumVal;
    }

    function clear() {
        payload = {};
    }

	return service;
}

export default {
	name: 'IntegratedData',
	fn: IntegratedData
};